package com.ruoyi.system.domain.grid;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class GridRegionExample implements Serializable {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private static final long serialVersionUID = 1L;

    public GridRegionExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria implements Serializable {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andWgTypeIsNull() {
            addCriterion("wg_type is null");
            return (Criteria) this;
        }

        public Criteria andWgTypeIsNotNull() {
            addCriterion("wg_type is not null");
            return (Criteria) this;
        }

        public Criteria andWgTypeEqualTo(String value) {
            addCriterion("wg_type =", value, "wgType");
            return (Criteria) this;
        }

        public Criteria andWgTypeNotEqualTo(String value) {
            addCriterion("wg_type <>", value, "wgType");
            return (Criteria) this;
        }

        public Criteria andWgTypeGreaterThan(String value) {
            addCriterion("wg_type >", value, "wgType");
            return (Criteria) this;
        }

        public Criteria andWgTypeGreaterThanOrEqualTo(String value) {
            addCriterion("wg_type >=", value, "wgType");
            return (Criteria) this;
        }

        public Criteria andWgTypeLessThan(String value) {
            addCriterion("wg_type <", value, "wgType");
            return (Criteria) this;
        }

        public Criteria andWgTypeLessThanOrEqualTo(String value) {
            addCriterion("wg_type <=", value, "wgType");
            return (Criteria) this;
        }

        public Criteria andWgTypeLike(String value) {
            addCriterion("wg_type like", value, "wgType");
            return (Criteria) this;
        }

        public Criteria andWgTypeNotLike(String value) {
            addCriterion("wg_type not like", value, "wgType");
            return (Criteria) this;
        }

        public Criteria andWgTypeIn(List<String> values) {
            addCriterion("wg_type in", values, "wgType");
            return (Criteria) this;
        }

        public Criteria andWgTypeNotIn(List<String> values) {
            addCriterion("wg_type not in", values, "wgType");
            return (Criteria) this;
        }

        public Criteria andWgTypeBetween(String value1, String value2) {
            addCriterion("wg_type between", value1, value2, "wgType");
            return (Criteria) this;
        }

        public Criteria andWgTypeNotBetween(String value1, String value2) {
            addCriterion("wg_type not between", value1, value2, "wgType");
            return (Criteria) this;
        }

        public Criteria andWgCodeIsNull() {
            addCriterion("wg_code is null");
            return (Criteria) this;
        }

        public Criteria andWgCodeIsNotNull() {
            addCriterion("wg_code is not null");
            return (Criteria) this;
        }

        public Criteria andWgCodeEqualTo(String value) {
            addCriterion("wg_code =", value, "wgCode");
            return (Criteria) this;
        }

        public Criteria andWgCodeNotEqualTo(String value) {
            addCriterion("wg_code <>", value, "wgCode");
            return (Criteria) this;
        }

        public Criteria andWgCodeGreaterThan(String value) {
            addCriterion("wg_code >", value, "wgCode");
            return (Criteria) this;
        }

        public Criteria andWgCodeGreaterThanOrEqualTo(String value) {
            addCriterion("wg_code >=", value, "wgCode");
            return (Criteria) this;
        }

        public Criteria andWgCodeLessThan(String value) {
            addCriterion("wg_code <", value, "wgCode");
            return (Criteria) this;
        }

        public Criteria andWgCodeLessThanOrEqualTo(String value) {
            addCriterion("wg_code <=", value, "wgCode");
            return (Criteria) this;
        }

        public Criteria andWgCodeLike(String value) {
            addCriterion("wg_code like", value, "wgCode");
            return (Criteria) this;
        }

        public Criteria andWgCodeNotLike(String value) {
            addCriterion("wg_code not like", value, "wgCode");
            return (Criteria) this;
        }

        public Criteria andWgCodeIn(List<String> values) {
            addCriterion("wg_code in", values, "wgCode");
            return (Criteria) this;
        }

        public Criteria andWgCodeNotIn(List<String> values) {
            addCriterion("wg_code not in", values, "wgCode");
            return (Criteria) this;
        }

        public Criteria andWgCodeBetween(String value1, String value2) {
            addCriterion("wg_code between", value1, value2, "wgCode");
            return (Criteria) this;
        }

        public Criteria andWgCodeNotBetween(String value1, String value2) {
            addCriterion("wg_code not between", value1, value2, "wgCode");
            return (Criteria) this;
        }

        public Criteria andWgNameIsNull() {
            addCriterion("wg_name is null");
            return (Criteria) this;
        }

        public Criteria andWgNameIsNotNull() {
            addCriterion("wg_name is not null");
            return (Criteria) this;
        }

        public Criteria andWgNameEqualTo(String value) {
            addCriterion("wg_name =", value, "wgName");
            return (Criteria) this;
        }

        public Criteria andWgNameNotEqualTo(String value) {
            addCriterion("wg_name <>", value, "wgName");
            return (Criteria) this;
        }

        public Criteria andWgNameGreaterThan(String value) {
            addCriterion("wg_name >", value, "wgName");
            return (Criteria) this;
        }

        public Criteria andWgNameGreaterThanOrEqualTo(String value) {
            addCriterion("wg_name >=", value, "wgName");
            return (Criteria) this;
        }

        public Criteria andWgNameLessThan(String value) {
            addCriterion("wg_name <", value, "wgName");
            return (Criteria) this;
        }

        public Criteria andWgNameLessThanOrEqualTo(String value) {
            addCriterion("wg_name <=", value, "wgName");
            return (Criteria) this;
        }

        public Criteria andWgNameLike(String value) {
            addCriterion("wg_name like", value, "wgName");
            return (Criteria) this;
        }

        public Criteria andWgNameNotLike(String value) {
            addCriterion("wg_name not like", value, "wgName");
            return (Criteria) this;
        }

        public Criteria andWgNameIn(List<String> values) {
            addCriterion("wg_name in", values, "wgName");
            return (Criteria) this;
        }

        public Criteria andWgNameNotIn(List<String> values) {
            addCriterion("wg_name not in", values, "wgName");
            return (Criteria) this;
        }

        public Criteria andWgNameBetween(String value1, String value2) {
            addCriterion("wg_name between", value1, value2, "wgName");
            return (Criteria) this;
        }

        public Criteria andWgNameNotBetween(String value1, String value2) {
            addCriterion("wg_name not between", value1, value2, "wgName");
            return (Criteria) this;
        }

        public Criteria andWgParentIdIsNull() {
            addCriterion("wg_parent_id is null");
            return (Criteria) this;
        }

        public Criteria andWgParentIdIsNotNull() {
            addCriterion("wg_parent_id is not null");
            return (Criteria) this;
        }

        public Criteria andWgParentIdEqualTo(String value) {
            addCriterion("wg_parent_id =", value, "wgParentId");
            return (Criteria) this;
        }

        public Criteria andWgParentIdNotEqualTo(String value) {
            addCriterion("wg_parent_id <>", value, "wgParentId");
            return (Criteria) this;
        }

        public Criteria andWgParentIdGreaterThan(String value) {
            addCriterion("wg_parent_id >", value, "wgParentId");
            return (Criteria) this;
        }

        public Criteria andWgParentIdGreaterThanOrEqualTo(String value) {
            addCriterion("wg_parent_id >=", value, "wgParentId");
            return (Criteria) this;
        }

        public Criteria andWgParentIdLessThan(String value) {
            addCriterion("wg_parent_id <", value, "wgParentId");
            return (Criteria) this;
        }

        public Criteria andWgParentIdLessThanOrEqualTo(String value) {
            addCriterion("wg_parent_id <=", value, "wgParentId");
            return (Criteria) this;
        }

        public Criteria andWgParentIdLike(String value) {
            addCriterion("wg_parent_id like", value, "wgParentId");
            return (Criteria) this;
        }

        public Criteria andWgParentIdNotLike(String value) {
            addCriterion("wg_parent_id not like", value, "wgParentId");
            return (Criteria) this;
        }

        public Criteria andWgParentIdIn(List<String> values) {
            addCriterion("wg_parent_id in", values, "wgParentId");
            return (Criteria) this;
        }

        public Criteria andWgParentIdNotIn(List<String> values) {
            addCriterion("wg_parent_id not in", values, "wgParentId");
            return (Criteria) this;
        }

        public Criteria andWgParentIdBetween(String value1, String value2) {
            addCriterion("wg_parent_id between", value1, value2, "wgParentId");
            return (Criteria) this;
        }

        public Criteria andWgParentIdNotBetween(String value1, String value2) {
            addCriterion("wg_parent_id not between", value1, value2, "wgParentId");
            return (Criteria) this;
        }

        public Criteria andWgAreaIsNull() {
            addCriterion("wg_area is null");
            return (Criteria) this;
        }

        public Criteria andWgAreaIsNotNull() {
            addCriterion("wg_area is not null");
            return (Criteria) this;
        }

        public Criteria andWgAreaEqualTo(String value) {
            addCriterion("wg_area =", value, "wgArea");
            return (Criteria) this;
        }

        public Criteria andWgAreaNotEqualTo(String value) {
            addCriterion("wg_area <>", value, "wgArea");
            return (Criteria) this;
        }

        public Criteria andWgAreaGreaterThan(String value) {
            addCriterion("wg_area >", value, "wgArea");
            return (Criteria) this;
        }

        public Criteria andWgAreaGreaterThanOrEqualTo(String value) {
            addCriterion("wg_area >=", value, "wgArea");
            return (Criteria) this;
        }

        public Criteria andWgAreaLessThan(String value) {
            addCriterion("wg_area <", value, "wgArea");
            return (Criteria) this;
        }

        public Criteria andWgAreaLessThanOrEqualTo(String value) {
            addCriterion("wg_area <=", value, "wgArea");
            return (Criteria) this;
        }

        public Criteria andWgAreaLike(String value) {
            addCriterion("wg_area like", value, "wgArea");
            return (Criteria) this;
        }

        public Criteria andWgAreaNotLike(String value) {
            addCriterion("wg_area not like", value, "wgArea");
            return (Criteria) this;
        }

        public Criteria andWgAreaIn(List<String> values) {
            addCriterion("wg_area in", values, "wgArea");
            return (Criteria) this;
        }

        public Criteria andWgAreaNotIn(List<String> values) {
            addCriterion("wg_area not in", values, "wgArea");
            return (Criteria) this;
        }

        public Criteria andWgAreaBetween(String value1, String value2) {
            addCriterion("wg_area between", value1, value2, "wgArea");
            return (Criteria) this;
        }

        public Criteria andWgAreaNotBetween(String value1, String value2) {
            addCriterion("wg_area not between", value1, value2, "wgArea");
            return (Criteria) this;
        }

        public Criteria andWgCentreCoordinateIsNull() {
            addCriterion("wg_centre_coordinate is null");
            return (Criteria) this;
        }

        public Criteria andWgCentreCoordinateIsNotNull() {
            addCriterion("wg_centre_coordinate is not null");
            return (Criteria) this;
        }

        public Criteria andWgCentreCoordinateEqualTo(String value) {
            addCriterion("wg_centre_coordinate =", value, "wgCentreCoordinate");
            return (Criteria) this;
        }

        public Criteria andWgCentreCoordinateNotEqualTo(String value) {
            addCriterion("wg_centre_coordinate <>", value, "wgCentreCoordinate");
            return (Criteria) this;
        }

        public Criteria andWgCentreCoordinateGreaterThan(String value) {
            addCriterion("wg_centre_coordinate >", value, "wgCentreCoordinate");
            return (Criteria) this;
        }

        public Criteria andWgCentreCoordinateGreaterThanOrEqualTo(String value) {
            addCriterion("wg_centre_coordinate >=", value, "wgCentreCoordinate");
            return (Criteria) this;
        }

        public Criteria andWgCentreCoordinateLessThan(String value) {
            addCriterion("wg_centre_coordinate <", value, "wgCentreCoordinate");
            return (Criteria) this;
        }

        public Criteria andWgCentreCoordinateLessThanOrEqualTo(String value) {
            addCriterion("wg_centre_coordinate <=", value, "wgCentreCoordinate");
            return (Criteria) this;
        }

        public Criteria andWgCentreCoordinateLike(String value) {
            addCriterion("wg_centre_coordinate like", value, "wgCentreCoordinate");
            return (Criteria) this;
        }

        public Criteria andWgCentreCoordinateNotLike(String value) {
            addCriterion("wg_centre_coordinate not like", value, "wgCentreCoordinate");
            return (Criteria) this;
        }

        public Criteria andWgCentreCoordinateIn(List<String> values) {
            addCriterion("wg_centre_coordinate in", values, "wgCentreCoordinate");
            return (Criteria) this;
        }

        public Criteria andWgCentreCoordinateNotIn(List<String> values) {
            addCriterion("wg_centre_coordinate not in", values, "wgCentreCoordinate");
            return (Criteria) this;
        }

        public Criteria andWgCentreCoordinateBetween(String value1, String value2) {
            addCriterion("wg_centre_coordinate between", value1, value2, "wgCentreCoordinate");
            return (Criteria) this;
        }

        public Criteria andWgCentreCoordinateNotBetween(String value1, String value2) {
            addCriterion("wg_centre_coordinate not between", value1, value2, "wgCentreCoordinate");
            return (Criteria) this;
        }

        public Criteria andWgPrincipalIsNull() {
            addCriterion("wg_principal is null");
            return (Criteria) this;
        }

        public Criteria andWgPrincipalIsNotNull() {
            addCriterion("wg_principal is not null");
            return (Criteria) this;
        }

        public Criteria andWgPrincipalEqualTo(String value) {
            addCriterion("wg_principal =", value, "wgPrincipal");
            return (Criteria) this;
        }

        public Criteria andWgPrincipalNotEqualTo(String value) {
            addCriterion("wg_principal <>", value, "wgPrincipal");
            return (Criteria) this;
        }

        public Criteria andWgPrincipalGreaterThan(String value) {
            addCriterion("wg_principal >", value, "wgPrincipal");
            return (Criteria) this;
        }

        public Criteria andWgPrincipalGreaterThanOrEqualTo(String value) {
            addCriterion("wg_principal >=", value, "wgPrincipal");
            return (Criteria) this;
        }

        public Criteria andWgPrincipalLessThan(String value) {
            addCriterion("wg_principal <", value, "wgPrincipal");
            return (Criteria) this;
        }

        public Criteria andWgPrincipalLessThanOrEqualTo(String value) {
            addCriterion("wg_principal <=", value, "wgPrincipal");
            return (Criteria) this;
        }

        public Criteria andWgPrincipalLike(String value) {
            addCriterion("wg_principal like", value, "wgPrincipal");
            return (Criteria) this;
        }

        public Criteria andWgPrincipalNotLike(String value) {
            addCriterion("wg_principal not like", value, "wgPrincipal");
            return (Criteria) this;
        }

        public Criteria andWgPrincipalIn(List<String> values) {
            addCriterion("wg_principal in", values, "wgPrincipal");
            return (Criteria) this;
        }

        public Criteria andWgPrincipalNotIn(List<String> values) {
            addCriterion("wg_principal not in", values, "wgPrincipal");
            return (Criteria) this;
        }

        public Criteria andWgPrincipalBetween(String value1, String value2) {
            addCriterion("wg_principal between", value1, value2, "wgPrincipal");
            return (Criteria) this;
        }

        public Criteria andWgPrincipalNotBetween(String value1, String value2) {
            addCriterion("wg_principal not between", value1, value2, "wgPrincipal");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(String value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(String value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(String value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(String value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(String value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(String value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLike(String value) {
            addCriterion("create_time like", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotLike(String value) {
            addCriterion("create_time not like", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<String> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<String> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(String value1, String value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(String value1, String value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateByIsNull() {
            addCriterion("create_by is null");
            return (Criteria) this;
        }

        public Criteria andCreateByIsNotNull() {
            addCriterion("create_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreateByEqualTo(String value) {
            addCriterion("create_by =", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotEqualTo(String value) {
            addCriterion("create_by <>", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByGreaterThan(String value) {
            addCriterion("create_by >", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByGreaterThanOrEqualTo(String value) {
            addCriterion("create_by >=", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLessThan(String value) {
            addCriterion("create_by <", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLessThanOrEqualTo(String value) {
            addCriterion("create_by <=", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLike(String value) {
            addCriterion("create_by like", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotLike(String value) {
            addCriterion("create_by not like", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByIn(List<String> values) {
            addCriterion("create_by in", values, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotIn(List<String> values) {
            addCriterion("create_by not in", values, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByBetween(String value1, String value2) {
            addCriterion("create_by between", value1, value2, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotBetween(String value1, String value2) {
            addCriterion("create_by not between", value1, value2, "createBy");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(String value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(String value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(String value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(String value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(String value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(String value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLike(String value) {
            addCriterion("update_time like", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotLike(String value) {
            addCriterion("update_time not like", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<String> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<String> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(String value1, String value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(String value1, String value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateByIsNull() {
            addCriterion("update_by is null");
            return (Criteria) this;
        }

        public Criteria andUpdateByIsNotNull() {
            addCriterion("update_by is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateByEqualTo(String value) {
            addCriterion("update_by =", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotEqualTo(String value) {
            addCriterion("update_by <>", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByGreaterThan(String value) {
            addCriterion("update_by >", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByGreaterThanOrEqualTo(String value) {
            addCriterion("update_by >=", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLessThan(String value) {
            addCriterion("update_by <", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLessThanOrEqualTo(String value) {
            addCriterion("update_by <=", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLike(String value) {
            addCriterion("update_by like", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotLike(String value) {
            addCriterion("update_by not like", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByIn(List<String> values) {
            addCriterion("update_by in", values, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotIn(List<String> values) {
            addCriterion("update_by not in", values, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByBetween(String value1, String value2) {
            addCriterion("update_by between", value1, value2, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotBetween(String value1, String value2) {
            addCriterion("update_by not between", value1, value2, "updateBy");
            return (Criteria) this;
        }

        public Criteria andLevelIsNull() {
            addCriterion("level is null");
            return (Criteria) this;
        }

        public Criteria andLevelIsNotNull() {
            addCriterion("level is not null");
            return (Criteria) this;
        }

        public Criteria andLevelEqualTo(String value) {
            addCriterion("level =", value, "level");
            return (Criteria) this;
        }

        public Criteria andLevelNotEqualTo(String value) {
            addCriterion("level <>", value, "level");
            return (Criteria) this;
        }

        public Criteria andLevelGreaterThan(String value) {
            addCriterion("level >", value, "level");
            return (Criteria) this;
        }

        public Criteria andLevelGreaterThanOrEqualTo(String value) {
            addCriterion("level >=", value, "level");
            return (Criteria) this;
        }

        public Criteria andLevelLessThan(String value) {
            addCriterion("level <", value, "level");
            return (Criteria) this;
        }

        public Criteria andLevelLessThanOrEqualTo(String value) {
            addCriterion("level <=", value, "level");
            return (Criteria) this;
        }

        public Criteria andLevelLike(String value) {
            addCriterion("level like", value, "level");
            return (Criteria) this;
        }

        public Criteria andLevelNotLike(String value) {
            addCriterion("level not like", value, "level");
            return (Criteria) this;
        }

        public Criteria andLevelIn(List<String> values) {
            addCriterion("level in", values, "level");
            return (Criteria) this;
        }

        public Criteria andLevelNotIn(List<String> values) {
            addCriterion("level not in", values, "level");
            return (Criteria) this;
        }

        public Criteria andLevelBetween(String value1, String value2) {
            addCriterion("level between", value1, value2, "level");
            return (Criteria) this;
        }

        public Criteria andLevelNotBetween(String value1, String value2) {
            addCriterion("level not between", value1, value2, "level");
            return (Criteria) this;
        }

        public Criteria andIsValidIsNull() {
            addCriterion("is_valid is null");
            return (Criteria) this;
        }

        public Criteria andIsValidIsNotNull() {
            addCriterion("is_valid is not null");
            return (Criteria) this;
        }

        public Criteria andIsValidEqualTo(String value) {
            addCriterion("is_valid =", value, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidNotEqualTo(String value) {
            addCriterion("is_valid <>", value, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidGreaterThan(String value) {
            addCriterion("is_valid >", value, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidGreaterThanOrEqualTo(String value) {
            addCriterion("is_valid >=", value, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidLessThan(String value) {
            addCriterion("is_valid <", value, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidLessThanOrEqualTo(String value) {
            addCriterion("is_valid <=", value, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidLike(String value) {
            addCriterion("is_valid like", value, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidNotLike(String value) {
            addCriterion("is_valid not like", value, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidIn(List<String> values) {
            addCriterion("is_valid in", values, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidNotIn(List<String> values) {
            addCriterion("is_valid not in", values, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidBetween(String value1, String value2) {
            addCriterion("is_valid between", value1, value2, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidNotBetween(String value1, String value2) {
            addCriterion("is_valid not between", value1, value2, "isValid");
            return (Criteria) this;
        }

        public Criteria andYlzd1IsNull() {
            addCriterion("ylzd1 is null");
            return (Criteria) this;
        }

        public Criteria andYlzd1IsNotNull() {
            addCriterion("ylzd1 is not null");
            return (Criteria) this;
        }

        public Criteria andYlzd1EqualTo(String value) {
            addCriterion("ylzd1 =", value, "ylzd1");
            return (Criteria) this;
        }

        public Criteria andYlzd1NotEqualTo(String value) {
            addCriterion("ylzd1 <>", value, "ylzd1");
            return (Criteria) this;
        }

        public Criteria andYlzd1GreaterThan(String value) {
            addCriterion("ylzd1 >", value, "ylzd1");
            return (Criteria) this;
        }

        public Criteria andYlzd1GreaterThanOrEqualTo(String value) {
            addCriterion("ylzd1 >=", value, "ylzd1");
            return (Criteria) this;
        }

        public Criteria andYlzd1LessThan(String value) {
            addCriterion("ylzd1 <", value, "ylzd1");
            return (Criteria) this;
        }

        public Criteria andYlzd1LessThanOrEqualTo(String value) {
            addCriterion("ylzd1 <=", value, "ylzd1");
            return (Criteria) this;
        }

        public Criteria andYlzd1Like(String value) {
            addCriterion("ylzd1 like", value, "ylzd1");
            return (Criteria) this;
        }

        public Criteria andYlzd1NotLike(String value) {
            addCriterion("ylzd1 not like", value, "ylzd1");
            return (Criteria) this;
        }

        public Criteria andYlzd1In(List<String> values) {
            addCriterion("ylzd1 in", values, "ylzd1");
            return (Criteria) this;
        }

        public Criteria andYlzd1NotIn(List<String> values) {
            addCriterion("ylzd1 not in", values, "ylzd1");
            return (Criteria) this;
        }

        public Criteria andYlzd1Between(String value1, String value2) {
            addCriterion("ylzd1 between", value1, value2, "ylzd1");
            return (Criteria) this;
        }

        public Criteria andYlzd1NotBetween(String value1, String value2) {
            addCriterion("ylzd1 not between", value1, value2, "ylzd1");
            return (Criteria) this;
        }

        public Criteria andYlzd2IsNull() {
            addCriterion("ylzd2 is null");
            return (Criteria) this;
        }

        public Criteria andYlzd2IsNotNull() {
            addCriterion("ylzd2 is not null");
            return (Criteria) this;
        }

        public Criteria andYlzd2EqualTo(String value) {
            addCriterion("ylzd2 =", value, "ylzd2");
            return (Criteria) this;
        }

        public Criteria andYlzd2NotEqualTo(String value) {
            addCriterion("ylzd2 <>", value, "ylzd2");
            return (Criteria) this;
        }

        public Criteria andYlzd2GreaterThan(String value) {
            addCriterion("ylzd2 >", value, "ylzd2");
            return (Criteria) this;
        }

        public Criteria andYlzd2GreaterThanOrEqualTo(String value) {
            addCriterion("ylzd2 >=", value, "ylzd2");
            return (Criteria) this;
        }

        public Criteria andYlzd2LessThan(String value) {
            addCriterion("ylzd2 <", value, "ylzd2");
            return (Criteria) this;
        }

        public Criteria andYlzd2LessThanOrEqualTo(String value) {
            addCriterion("ylzd2 <=", value, "ylzd2");
            return (Criteria) this;
        }

        public Criteria andYlzd2Like(String value) {
            addCriterion("ylzd2 like", value, "ylzd2");
            return (Criteria) this;
        }

        public Criteria andYlzd2NotLike(String value) {
            addCriterion("ylzd2 not like", value, "ylzd2");
            return (Criteria) this;
        }

        public Criteria andYlzd2In(List<String> values) {
            addCriterion("ylzd2 in", values, "ylzd2");
            return (Criteria) this;
        }

        public Criteria andYlzd2NotIn(List<String> values) {
            addCriterion("ylzd2 not in", values, "ylzd2");
            return (Criteria) this;
        }

        public Criteria andYlzd2Between(String value1, String value2) {
            addCriterion("ylzd2 between", value1, value2, "ylzd2");
            return (Criteria) this;
        }

        public Criteria andYlzd2NotBetween(String value1, String value2) {
            addCriterion("ylzd2 not between", value1, value2, "ylzd2");
            return (Criteria) this;
        }

        public Criteria andYlzd3IsNull() {
            addCriterion("ylzd3 is null");
            return (Criteria) this;
        }

        public Criteria andYlzd3IsNotNull() {
            addCriterion("ylzd3 is not null");
            return (Criteria) this;
        }

        public Criteria andYlzd3EqualTo(String value) {
            addCriterion("ylzd3 =", value, "ylzd3");
            return (Criteria) this;
        }

        public Criteria andYlzd3NotEqualTo(String value) {
            addCriterion("ylzd3 <>", value, "ylzd3");
            return (Criteria) this;
        }

        public Criteria andYlzd3GreaterThan(String value) {
            addCriterion("ylzd3 >", value, "ylzd3");
            return (Criteria) this;
        }

        public Criteria andYlzd3GreaterThanOrEqualTo(String value) {
            addCriterion("ylzd3 >=", value, "ylzd3");
            return (Criteria) this;
        }

        public Criteria andYlzd3LessThan(String value) {
            addCriterion("ylzd3 <", value, "ylzd3");
            return (Criteria) this;
        }

        public Criteria andYlzd3LessThanOrEqualTo(String value) {
            addCriterion("ylzd3 <=", value, "ylzd3");
            return (Criteria) this;
        }

        public Criteria andYlzd3Like(String value) {
            addCriterion("ylzd3 like", value, "ylzd3");
            return (Criteria) this;
        }

        public Criteria andYlzd3NotLike(String value) {
            addCriterion("ylzd3 not like", value, "ylzd3");
            return (Criteria) this;
        }

        public Criteria andYlzd3In(List<String> values) {
            addCriterion("ylzd3 in", values, "ylzd3");
            return (Criteria) this;
        }

        public Criteria andYlzd3NotIn(List<String> values) {
            addCriterion("ylzd3 not in", values, "ylzd3");
            return (Criteria) this;
        }

        public Criteria andYlzd3Between(String value1, String value2) {
            addCriterion("ylzd3 between", value1, value2, "ylzd3");
            return (Criteria) this;
        }

        public Criteria andYlzd3NotBetween(String value1, String value2) {
            addCriterion("ylzd3 not between", value1, value2, "ylzd3");
            return (Criteria) this;
        }

        public Criteria andYlzd4IsNull() {
            addCriterion("ylzd4 is null");
            return (Criteria) this;
        }

        public Criteria andYlzd4IsNotNull() {
            addCriterion("ylzd4 is not null");
            return (Criteria) this;
        }

        public Criteria andYlzd4EqualTo(String value) {
            addCriterion("ylzd4 =", value, "ylzd4");
            return (Criteria) this;
        }

        public Criteria andYlzd4NotEqualTo(String value) {
            addCriterion("ylzd4 <>", value, "ylzd4");
            return (Criteria) this;
        }

        public Criteria andYlzd4GreaterThan(String value) {
            addCriterion("ylzd4 >", value, "ylzd4");
            return (Criteria) this;
        }

        public Criteria andYlzd4GreaterThanOrEqualTo(String value) {
            addCriterion("ylzd4 >=", value, "ylzd4");
            return (Criteria) this;
        }

        public Criteria andYlzd4LessThan(String value) {
            addCriterion("ylzd4 <", value, "ylzd4");
            return (Criteria) this;
        }

        public Criteria andYlzd4LessThanOrEqualTo(String value) {
            addCriterion("ylzd4 <=", value, "ylzd4");
            return (Criteria) this;
        }

        public Criteria andYlzd4Like(String value) {
            addCriterion("ylzd4 like", value, "ylzd4");
            return (Criteria) this;
        }

        public Criteria andYlzd4NotLike(String value) {
            addCriterion("ylzd4 not like", value, "ylzd4");
            return (Criteria) this;
        }

        public Criteria andYlzd4In(List<String> values) {
            addCriterion("ylzd4 in", values, "ylzd4");
            return (Criteria) this;
        }

        public Criteria andYlzd4NotIn(List<String> values) {
            addCriterion("ylzd4 not in", values, "ylzd4");
            return (Criteria) this;
        }

        public Criteria andYlzd4Between(String value1, String value2) {
            addCriterion("ylzd4 between", value1, value2, "ylzd4");
            return (Criteria) this;
        }

        public Criteria andYlzd4NotBetween(String value1, String value2) {
            addCriterion("ylzd4 not between", value1, value2, "ylzd4");
            return (Criteria) this;
        }

        public Criteria andYlzd5IsNull() {
            addCriterion("ylzd5 is null");
            return (Criteria) this;
        }

        public Criteria andYlzd5IsNotNull() {
            addCriterion("ylzd5 is not null");
            return (Criteria) this;
        }

        public Criteria andYlzd5EqualTo(String value) {
            addCriterion("ylzd5 =", value, "ylzd5");
            return (Criteria) this;
        }

        public Criteria andYlzd5NotEqualTo(String value) {
            addCriterion("ylzd5 <>", value, "ylzd5");
            return (Criteria) this;
        }

        public Criteria andYlzd5GreaterThan(String value) {
            addCriterion("ylzd5 >", value, "ylzd5");
            return (Criteria) this;
        }

        public Criteria andYlzd5GreaterThanOrEqualTo(String value) {
            addCriterion("ylzd5 >=", value, "ylzd5");
            return (Criteria) this;
        }

        public Criteria andYlzd5LessThan(String value) {
            addCriterion("ylzd5 <", value, "ylzd5");
            return (Criteria) this;
        }

        public Criteria andYlzd5LessThanOrEqualTo(String value) {
            addCriterion("ylzd5 <=", value, "ylzd5");
            return (Criteria) this;
        }

        public Criteria andYlzd5Like(String value) {
            addCriterion("ylzd5 like", value, "ylzd5");
            return (Criteria) this;
        }

        public Criteria andYlzd5NotLike(String value) {
            addCriterion("ylzd5 not like", value, "ylzd5");
            return (Criteria) this;
        }

        public Criteria andYlzd5In(List<String> values) {
            addCriterion("ylzd5 in", values, "ylzd5");
            return (Criteria) this;
        }

        public Criteria andYlzd5NotIn(List<String> values) {
            addCriterion("ylzd5 not in", values, "ylzd5");
            return (Criteria) this;
        }

        public Criteria andYlzd5Between(String value1, String value2) {
            addCriterion("ylzd5 between", value1, value2, "ylzd5");
            return (Criteria) this;
        }

        public Criteria andYlzd5NotBetween(String value1, String value2) {
            addCriterion("ylzd5 not between", value1, value2, "ylzd5");
            return (Criteria) this;
        }

        public Criteria andWgPurposeIsNull() {
            addCriterion("wg_purpose is null");
            return (Criteria) this;
        }

        public Criteria andWgPurposeIsNotNull() {
            addCriterion("wg_purpose is not null");
            return (Criteria) this;
        }

        public Criteria andWgPurposeEqualTo(String value) {
            addCriterion("wg_purpose =", value, "wgPurpose");
            return (Criteria) this;
        }

        public Criteria andWgPurposeNotEqualTo(String value) {
            addCriterion("wg_purpose <>", value, "wgPurpose");
            return (Criteria) this;
        }

        public Criteria andWgPurposeGreaterThan(String value) {
            addCriterion("wg_purpose >", value, "wgPurpose");
            return (Criteria) this;
        }

        public Criteria andWgPurposeGreaterThanOrEqualTo(String value) {
            addCriterion("wg_purpose >=", value, "wgPurpose");
            return (Criteria) this;
        }

        public Criteria andWgPurposeLessThan(String value) {
            addCriterion("wg_purpose <", value, "wgPurpose");
            return (Criteria) this;
        }

        public Criteria andWgPurposeLessThanOrEqualTo(String value) {
            addCriterion("wg_purpose <=", value, "wgPurpose");
            return (Criteria) this;
        }

        public Criteria andWgPurposeLike(String value) {
            addCriterion("wg_purpose like", value, "wgPurpose");
            return (Criteria) this;
        }

        public Criteria andWgPurposeNotLike(String value) {
            addCriterion("wg_purpose not like", value, "wgPurpose");
            return (Criteria) this;
        }

        public Criteria andWgPurposeIn(List<String> values) {
            addCriterion("wg_purpose in", values, "wgPurpose");
            return (Criteria) this;
        }

        public Criteria andWgPurposeNotIn(List<String> values) {
            addCriterion("wg_purpose not in", values, "wgPurpose");
            return (Criteria) this;
        }

        public Criteria andWgPurposeBetween(String value1, String value2) {
            addCriterion("wg_purpose between", value1, value2, "wgPurpose");
            return (Criteria) this;
        }

        public Criteria andWgPurposeNotBetween(String value1, String value2) {
            addCriterion("wg_purpose not between", value1, value2, "wgPurpose");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria implements Serializable {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion implements Serializable {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}